fill -64 -8 -64 64 6 64 air
forceload remove all
$execute positioned $(dungeon_offset) 0 0 run forceload add ~-64 ~-64 ~64 ~64
$scoreboard players set #math bungeon.temp $(dungeon_offset)
execute store result storage bungeon:data dungeon_offset int 1 run scoreboard players add #math bungeon.temp 16
$execute positioned $(dungeon_offset) 0 0 run place structure bungeon:dungeon

# Reset Drops
data modify storage bungeon:data drops set value []
scoreboard players set #dropcount bungeon.id 0
kill @e[tag=drop]

# Room Initialization
scoreboard players set #room bungeon.id 0
execute as @e[type=marker, tag=room_marker] at @s run function bungeon:dungeon/generate/new/room/init with entity @s data
data modify entity @e[type=marker, tag=room_marker, tag=!start_room, limit=1, sort=random] data.type set value "end"

# Corridor Corrections
execute as @e[type=marker, tag=corridor_marker] at @s run function bungeon:dungeon/generate/new/corridor with entity @s data
execute as @e[tag=corridor_stand, type=armor_stand] at @s positioned ^ ^ ^1 unless entity @e[type=armor_stand, tag=corridor_stand, distance=...1] positioned ^ ^ ^-1 run function bungeon:dungeon/generate/new/remove_corridor

kill @e[tag=corridor_stand, type=armor_stand]
kill @e[tag=room_stand, type=armor_stand]

# Start Game Loop
fill 1 19 -2 -1 23 -2 stone_bricks
execute as @n[type=marker, tag=start_room] at @s run schedule function bungeon:dungeon/generate/new/offset/redirect 10t

execute as @n[type=marker, tag=start_room] at @s run function bungeon:dungeon/generate/room/clear/init with entity @s data
function bungeon:dungeon/game_loop/searching