attribute @s minecraft:generic.attack_damage base set 0
attribute @s minecraft:generic.attack_speed base set 4
gamemode adventure @s[tag=!dev]

# Remove Vanilla Systems
effect give @s minecraft:resistance infinite 255 true
effect give @s minecraft:saturation infinite 255 true

# Give coins
execute store result score #coins bungeon.temp run clear @s gold_nugget
scoreboard players operation @s bungeon.coins += #coins bungeon.temp
execute if score #coins bungeon.temp matches 1.. run advancement grant @s only bungeon:detection/reorder_inventory

# Drop Items
execute unless data entity @s SelectedItem at @n[type=item, distance=..2, nbt={Age:0s}] run function bungeon:player/item/drop/init with storage bungeon:data
kill @n[type=item, distance=..2, nbt={Age:0s}, nbt=!{Item:{id:"minecraft:gold_nugget"}}]

# Update Gui
$function bungeon:player/run/stats/health/display with storage bungeon:data players.$(name).gui

# Held Item
#scoreboard players set @s bungeon.temp -1
#execute if predicate bungeon:crouching run scoreboard players operation @s bungeon.map *= @s[scores={bungeon.crouch_last=0}] bungeon.temp
#execute store result score @s bungeon.crouch_last if predicate bungeon:crouching
execute unless score @s bungeon.transfer_id matches 0.. as @s[gamemode=!creative, predicate=!bungeon:crouching] run function bungeon:player/item/held/tick with storage bungeon:data
execute unless score @s bungeon.transfer_id matches 0.. as @s[gamemode=!creative, predicate=bungeon:crouching] run function bungeon:player/item/held/map
$execute as @s[scores={bungeon.transfer_id=0..}] run function bungeon:player/item/held/transfer/tick with storage bungeon:data players.$(name).gui.transfer

# Statistics
scoreboard players set @s bungeon.temp 100
$execute store result score #math bungeon.temp run data get storage bungeon:data players.$(name).stats.speed
execute store result storage bungeon:data temp float 0.00001 run scoreboard players operation @s bungeon.temp *= #math bungeon.temp
function bungeon:player/run/stats/update_speed with storage bungeon:data

function bungeon:player/run/stats/health/update with storage bungeon:data
scoreboard players remove @s[scores={bungeon.cooldown=1..}] bungeon.cooldown 100
scoreboard players remove @s bungeon.iframe 1
scoreboard players remove @s[scores={bungeon.blocking=1..}] bungeon.blocking 1
scoreboard players add @s[scores={bungeon.blocking=..-1}] bungeon.blocking 1

item replace entity @s player.cursor with air

execute as @s[predicate=bungeon:in_void] run function bungeon:player/run/exit/check